include "path.sol"
include "tools.sol"
include "options.sol"


array extensions = {"htm", "html", "php", "php3", "php4", "php5", "asp",
    "shtml", "dhtml", "jsp", "xhtml", "sol", "txt"}

array pagext = {"htm", "html", "php", "php3", "php4", "php5", "asp",
    "shtml", "dhtml", "jsp", "xhtml"}


`` Retrieve the local path of the file from a link

text, boolean localPath(text name)

	boolean local = true

	if hasProtocol(name)
		int l = siteURL.length()
		if siteURL[ -- l] = "/" let l - 1						  // remove trailing slash from offset count
		text lowname = name.lower()
		if lowname[ -- l] = siteURL							  // compare url with our website
			if name[l] = "/" let l + 1		
			if lowname.length() > l
				name = Path.merge(localRoot, name[l .. ]) // add local base to remote path 
				if WINDOWS let name = setWindows(name)
			else
				name = ""
			/if	
			//print "LOCAL? ", siteURL, "=", lowname[ -- l] , ":", name
		else
			if VERBOSE or DEBUG
				print name, "not in this website, ignored."
			/if	
			local = false
		/if	
	/if	
		
return name, local


boolean validExtension(text fname)
	text node
	text ext
	node, ext = Path.splitExt(fname)
	
  ` only html pages are parsed for links
	if ext.lower()  in extensions return true
return false



boolean parsable(text fname)
	text node
	text ext
	node, ext = Path.splitExt(fname)
	
  ` only html pages are parsed for links
	if ext.lower()  in pagext return true
return false



`` get the local part 

text getLocal(text theurl)
	int offset = siteOffset(theurl)
	if offset = nil ? return theurl
	offset = theurl.find("/", offset)
	if offset = nil return theurl
return theurl[offset +1 ..]

`` get the relative directory

text getRelativePath(text fpath)

	int l =  localRoot.length()
	if fpath.length() > l
		//print "Get RELATIVE", localRoot , fpath, (localRoot = fpath[ -- l])
		if localRoot = fpath[ -- l]
			fpath = fpath[ l + 1 .. ]		// remove local root and skip slash 
		/if
	/if
return fpath	


// create a link with the url, from the local path and the filename

text createLink(text url, text local, text name)
	text link = Path.merge(url, getRelativePath(local))
	//print "URL", url, "local", local, "RELATIVE", getRelativePath(local)
	link = Path.merge(link, name)
return link
